#!/bin/bash
MySQLuser='*** your username here ***'
MySQLpass='*** your password here ***'
MySQLDB='VZManagement'
MySQLhost='localhost'
TempFile='tempvzmanagement'
 
QueryVZpollInsert='INSERT INTO VZPollEvents (Active) VALUES (true)'
QueryVZpollLast='SELECT ID FROM VZPollEvents ORDER BY DateStamp DESC LIMIT 1'
QueryVZhosts='SELECT ID, PrimaryIP, Hostname, SSHUser FROM VZHosts WHERE active=true ORDER BY Hostname'
QueryVZhostsPubKeyUpdate='UPDATE VZHosts SET SSHPubKey='
QueryVZhostsPubKeyLengthUpdate='UPDATE VZHosts SET SSHPubKeyLength='
QueryVZhostsPubKeyDateUpdate='UPDATE VZHosts SET SSHPubKeyDate='
QuerySSHpubKeys='SELECT SSHPubKey FROM StaffSSHPubKeys UNION ALL SELECT SSHPubKey FROM VZHosts'
QueryVZcontainersInsert='INSERT INTO VZContainers (VZPollEventID, VZHostID, PrimaryIP, CTID, Hostname, Status) VALUES ('
QueryVZcontainersCPUupdate='UPDATE VZContainers SET CPUusage='
QueryVZcontainersMemUpdate='UPDATE VZContainers SET MemUsage='
QueryVZcontainersIPupdate='UPDATE VZContainers SET SecondaryIPs='
QueryVZcontainersMountUpdate='UPDATE VZContainers SET DiskMountPoint='
QueryVZcontainersDiskQuotaStatusUpdate='UPDATE VZContainers SET DiskQuotaStatus='
 
mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZpollInsert"
mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZpollLast" | while read PollID; do
        mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZhosts" | while read HostID PrimaryIP Hostname SSHUser; do
                ssh -t -t $SSHUser@$PrimaryIP > $TempFile <<-EOF
                        grep ssh-rsa /root/.ssh/id_rsa.pub | awk -F ' ' {'print "=+-=+-=+-,"\$1","\$2","\$3'}
                        ls -l .ssh/id_rsa --time-style='long-iso' | awk {'print "=+)=+)=+),"\$6":"\$7'}
                        openssl rsa -in .ssh/id_rsa -text -noout | grep "^Private-Key:" | cut -d "(" -f 2 | awk {'print "=+_=+_=+_,"\$1'}
                        vzlist -a 2> /dev/null | grep -v CTID | awk {'print "=+1=+1=+1,"\$1","\$3","\$4","\$5'}
                        vzcpucheck -v | grep -v "^VEID" | grep -v "^---" | grep -v "^Current" | grep -v "^Power" | grep -v "^0" | awk -F ' ' {'print "=+2=+2=+2,"\$1","\$2'}
                        vzmemcheck -vA | grep -v "^Output" | grep -v "^CTID" | grep -v "util  commit    util  commit" | grep -v "^---" | grep -v "^Summary:" | grep -v "^ " | awk -F ' ' {'print "=+3=+3=+3,"\$1","\$4","\$9'}
                        grep IP_A /etc/vz/conf/*.conf | grep -v -i des | cut -d "/" -f 5 | sed 's/.conf//g' | sed 's/IP_ADDRESS//g' | sed 's/"//g' | sed 's/:=/,/g' | sed 's/ /,/g' | awk -F ':' {'print "=+4=+4=+4,"\$1'}
                        grep VE_PRIVATE /etc/vz/conf/*.conf | grep -v -i des | cut -d "/" -f 5- | sed 's/.conf//g' | sed 's/VE_PRIVATE//g' | cut -d "/" -f -2 | sed 's/:=\"/,/g' | awk -F ':' {'print "=+5=+5=+5,"\$1'}
                        grep DISK_QUOTA /etc/vz/conf/*.conf | grep -v -i des | cut -d "/" -f 5 | sed 's/.conf:DISK_QUOTA=/,/g' | awk -F ' ' {'print "=+6=+6=+6,"\$1'}
                        #cd /vz/private
                        #du -s *
                        exit
                EOF
                for line in $(cat $TempFile | grep "^=+-=+-=+-"); do
                        TempPubKey1=`echo $line | cut -d "," -f 2`
                        TempPubKey2=`echo $line | cut -d "," -f 3`
                        TempPubKey3=`echo $line | cut -d "," -f 4`
                        mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZhostsPubKeyUpdate'$TempPubKey1 $TempPubKey2 $TempPubKey3' WHERE ID='$HostID'"
                done
                for line in $(cat $TempFile | grep "^=+_=+_=+_"); do
                        TempPubKeyLength=`echo $line | cut -d "," -f 2`
                        mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZhostsPubKeyLengthUpdate'$TempPubKeyLength' WHERE ID='$HostID'"
                done
                for line in $(cat $TempFile | grep "^=+)=+)=+)"); do
                        TempPubKeyDate=`echo $line | cut -d "," -f 2`
                        mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZhostsPubKeyDateUpdate'$TempPubKeyDate' WHERE ID='$HostID'"
                done
                for line in $(cat $TempFile | grep "^=+1=+1=+1"); do
                        TempCTID=`echo $line | cut -d "," -f 2`
                        TempStatus=`echo $line | cut -d "," -f 3`
                        TempPrimaryIP=`echo $line | cut -d "," -f 4`
                        TempHostname=`echo $line | cut -d "," -f 5`
                        mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZcontainersInsert'$PollID','$HostID','$TempPrimaryIP','$TempCTID','$TempHostname','$TempStatus')"
                done
                for line in $(cat $TempFile | grep "^=+2=+2=+2"); do
                        TempCTID=`echo $line | cut -d "," -f 2`
                        TempCPUusage=`echo $line | cut -d "," -f 3`
                        mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZcontainersCPUupdate'$TempCPUusage' WHERE VZPollEventID='$PollID' AND VZHostID='$HostID' AND CTID='$TempCTID'"
                done
                for line in $(cat $TempFile | grep "^=+3=+3=+3"); do
                        TempCTID=`echo $line | cut -d "," -f 2`
                        TempMemUsage=`echo $line | cut -d "," -f 3`
                        TempMemLimit=`echo $line | cut -d "," -f 4`
                        mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZcontainersMemUpdate'$TempMemUsage', MemLimit='$TempMemLimit' WHERE VZPollEventID='$PollID' AND VZHostID='$HostID' AND CTID='$TempCTID'"
                done
                for line in $(cat $TempFile | grep "^=+4=+4=+4"); do
                        TempCTID=`echo $line | cut -d "," -f 2`
                        TempIPs=`echo $line | cut -d "," -f 4-`
                        mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZcontainersIPupdate'$TempIPs' WHERE VZPollEventID='$PollID' AND VZHostID='$HostID' AND CTID='$TempCTID'"
                done
                for line in $(cat $TempFile | grep "^=+5=+5=+5"); do
                        TempCTID=`echo $line | cut -d "," -f 2`
                        TempMount=`echo ${line%?} | cut -d "," -f 3`
                        mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZcontainersMountUpdate'$TempMount' WHERE VZPollEventID='$PollID' AND VZHostID='$HostID' AND CTID='$TempCTID'"
                done
                for line in $(cat $TempFile | grep "^=+6=+6=+6"); do
                        TempCTID=`echo $line | cut -d "," -f 2`
                        TempDiskStatus=`echo $line | cut -d "," -f 3`
                        mysql -N -u$MySQLuser -p$MySQLpass -h$MySQLhost -D$MySQLDB -e "$QueryVZcontainersDiskQuotaStatusUpdate'$TempDiskStatus' WHERE VZPollEventID='$PollID' AND VZHostID='$HostID' AND CTID='$TempCTID'"
                done
        done
        rm -rf $TempFile
done
